<template>
    <div class="startups-filter">
        <base-filter :params="filterParams"
            v-model="filterData"
            :pickerOptions="pickerOptions"
            @apply="initFilter"
            @reset="resetFilter"
        >
            <download-csv-btn slot="btns-after" :filter="filterData" list-type="startups"/>
        </base-filter>
    </div>
</template>

<script>
import { startupsFilterSettings, defaultStartupsFilter } from '@/constants/ui/filters';
import { mapState } from 'vuex';
import filterMixin from '@/mixins/filterMixin';
import BaseFilter from './baseFilter';
import DownloadCsvBtn from '@/components/DownloadCsvBtn';

export default {
    name: 'startupsFilter',
    components: {
        BaseFilter,
        DownloadCsvBtn,
    },
    mixins: [filterMixin],
    data() {
        return {
            filterSettings: startupsFilterSettings,
            filterData: defaultStartupsFilter,
        };
    },
    computed: {
        ...mapState({
            serverFilter: state => state.users.startups_filter,
        }),
    },
    methods: {
        /** Apply new startup filter params */
        initFilter() {
            this.initLoading(this.$store.dispatch('filterStartupsList', this.filterData));
        },
        /** Reset current startup filter params */
        resetFilter() {
            this.filterData = { ...defaultStartupsFilter };
            this.$store.commit('clearStartupsFilter');
        },
    },
};
</script>
